﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Remoting.Channels;
using System.Text;
using System.Threading.Tasks;
using System.Net;
using System.Net.Sockets;

namespace ConsoleApplication1
{
    class Program
    {
        private static TcpListener server = null; 

        private static List<byte> alldata = new List<byte>();

        static void Main(string[] args)
        {
            try
            {
                var rnd = new Random();

                const int portNumber = 1337;
                var localAddress = IPAddress.Parse("192.168.20.93");
                server = new TcpListener(localAddress, portNumber);
                server.Start();

                var bytes = new Byte[2048];
                var dataBuffer = string.Empty;
                var totalBytesReceived = 0L;
                while (true)
                {
                    Console.Write("Waiting for a connection... ");

                    // Perform a blocking call to accept requests. You could also user server.AcceptSocket() here.
                    var client = server.AcceptTcpClient(); // blocking call
                    Console.WriteLine("Connected at {0}", DateTime.Now);

                    dataBuffer = string.Empty;

                    // Get a stream object for reading and writing
                    var stream = client.GetStream();
                    Console.WriteLine("Stream opened at {0}", DateTime.Now);

                    // Loop to receive all the data sent by the client. 
                    while (client.Connected && totalBytesReceived < 160000)
                    {
                        var bytesRead = stream.Read(bytes, 0, bytes.Length); // blocking call

                        alldata.AddRange(bytes.Take(bytesRead));
                        totalBytesReceived += bytesRead;
                        Console.WriteLine("{0} - bytes received: {1}, total: {2}", DateTime.Now, bytesRead, totalBytesReceived);

                        if (rnd.NextDouble() > 0.9)
                        {
                            Console.WriteLine("Sleeping...");
                            System.Threading.Thread.Sleep(5000);
                        }
                    }


                    // Shutdown and end connection
                    client.Close();
                    Console.WriteLine("Connection closed at {0}", DateTime.Now);

                    var s = "";
                    var a = "";
                    for (var i = 0; i < alldata.Count; i++)
                    {
                        s += alldata[i].ToString("X2") + " ";
                        a += ((alldata[i] >= 32 && alldata[i] <= 127) ? Encoding.ASCII.GetString(alldata.Skip(i).Take(1).ToArray()) : ".");

                        if ((i + 1)%32 > 0)
                            continue;

                        Console.WriteLine("\t{0}| {1}", s, a);
                        s = "";
                        a = "";
                    }

                    if (s.Length > 0)
                    {
                        Console.WriteLine("\t{0}| {1}", s, a);
                        s = "";
                        a = "";
                    }

                    alldata.Clear();
                    totalBytesReceived = 0;
                }
            }
            catch (SocketException ex)
            {
                Console.WriteLine("SocketException: {0}", ex);
            }
            finally
            {
                server.Stop();
            }

            Console.WriteLine("\nServer ended. Press Enter to exit...");
            Console.ReadLine();
        }
    }
}
