﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO.Ports;

namespace ConsoleApplication2
{
    class Program
    {
        private static SerialPort port = new SerialPort()
        {
            PortName = "COM2",
            Handshake = Handshake.RequestToSend,
            BaudRate = 230400,
            DataBits = 8,
            Parity = Parity.None,
            StopBits = StopBits.One
        };

        static void Main(string[] args)
        {
            port.Open();

            var buffer = new List<byte>();

            System.Threading.Thread.Sleep(5000);
            var totalBytesSent = 0L;

            for (var i = 0; i < 1000; i++)
            {
                while (port.CtsHolding == false)
                {
                    const int sleepTime = 1000;
                    System.Threading.Thread.Sleep(sleepTime);
                    Console.WriteLine("Cts OFF, sleeping {0}ms", sleepTime);
                }
                Console.WriteLine("Cts ON");

                buffer.Clear();
                buffer.AddRange(Enumerable.Repeat((byte)(0xa5 + (i % 10)), 160));

                port.Write(buffer.ToArray(), 0, buffer.Count);

                totalBytesSent += 160;

                Console.WriteLine("Bytes sent: {0}", totalBytesSent);
                System.Threading.Thread.Sleep(50);

                //for (var j = 0; j < 10; j++)
                //{
                //    System.Threading.Thread.Sleep(5);
                //    Console.WriteLine("          CtsHolding:{0}, CDHolding:{1}, DsrHolding:{2}, DtrEnable:{3}", 
                //        port.CtsHolding, port.CDHolding, port.DsrHolding, port.DtrEnable);
                //}
            }

            System.Threading.Thread.Sleep(1000);
            port.Close();
        }
    }
}
